#!/bin/ash
N=""
[ "$1" ] && N="-$1"
TMPDIR=/tmp/hardware-test
mkdir $TMPDIR
RESULTS="$TMPDIR/results$N"
ERRORS="$TMPDIR/errors$N"

exec >$RESULTS
exec 2>$ERRORS


# run tests
echo "---------- testing test-eide ----------" 
test-eide 
echo "---------- finished test-eide ----------" 
sync
echo "---------- testing test-scsi ----------" 
file `which test-scsi`
test-scsi
echo "---------- finished test-scsi ----------" 
sync
echo "---------- testing probepart ----------" 
# run "file" so we know if it's the binary or script...
file `which probepart`
probepart -k
echo "---------- finished probepart ----------" 
sync
echo "---------- testing probedisk ----------" 
# run "file" so we know if it's the binary or script...
file `which probedisk`
probedisk
echo "---------- finished probedisk ----------" 
sync
# done with libHW apps
echo "---------- testing fdisk ----------" 
fdisk -l
echo "---------- finished fdisk ----------" 
sync
echo "---------- testing elspci ----------" 
elspci -l
echo "---------- finished elspci ----------" 
sync
echo "---------- testing lspci1 ----------" 
lspci -n
echo "---------- finished lspci1 ----------" 
sync
echo "---------- testing lspci2 ----------" 
lspci -i /usr/share/pci-usb-pcmcia.ids
echo "---------- finished lspci2 ----------" 
sync
### now run a loop over partitions/devices
echo -e '\n######################### starting loop #########################'
for ADEV in `grep -E '[sh]d[a-z]|sr[0-9]' /proc/diskstats | tr -s ' ' | cut -d' ' -f4`
do
echo -e "\n\n------------------------- checking $ADEV -------------------------"
# first look dor directories in /sys and /proc
if [ -d /sys/block/$ADEV ] ; then #device, get info on it
  ADIR="/sys/block/$ADEV"
  echo "---------- looking in $ADIR ----------"
  echo -e "\n--listing files:"
  ls $ADIR/
  echo -e "\nremovable is |`cat $ADIR/removable`|"
  echo -e "\n--listing $ADIR/device:"
  ls $ADIR/device/
  echo -e "\nmedia is |`cat $ADIR/device/media`|"
  echo -e "\nmodel is |`cat $ADIR/device/model`|"
  echo -e "\nvendor is |`cat $ADIR/device/vendor`|"
  echo "---------- finished in $ADIR ----------"
  sync
fi
if [ -d /proc/ide/$ADEV ] ; then
  ADIR="/proc/ide/$ADEV"
  echo "---------- looking in $ADIR ----------"
  echo -e "\n--listing files:"
  ls $ADIR/
  echo -e "\nmedia is |`cat $ADIR/media`|"
  echo -e "\nmodel is |`cat $ADIR/model`|"
  echo -e "\nvendor is |`cat $ADIR/vendor`|"
  echo "---------- finished in $ADIR ----------"
  sync
fi
# now run some tests
echo "---------- testing fdisk ----------" 
fdisk -l /dev/$ADEV 2>&1
echo "---------- finished fdisk ----------" 
sync
echo "---------- testing disktype ----------" 
disktype /dev/$ADEV
echo "---------- finished disktype ----------" 
sync
if [ -f /usr/bin/file ] ; then
 echo "---------- testing 'file' ----------" 
 file -Ls /dev/$ADEV
 echo "---------- finished 'file' ----------" 
 sync
fi
done 
echo -e '\n######################### finished loop #########################'
# cat some useful files
echo -e "\n--------------- start /proc/scsi/scsi ---------------" 
cat /proc/scsi/scsi
echo "--------------- finished /proc/scsi/scsi ---------------" 
sync
echo "--------------- start /proc/bus/usb/devices ---------------" 
cat /proc/bus/usb/devices
echo "--------------- finished /proc/bus/usb/devices ---------------" 
sync
echo "--------------- start /proc/bus/input/devices ---------------" 
cat /proc/bus/input/devices
echo "--------------- finished /proc/bus/input/devices ---------------" 
sync
echo "--------------- start ddcprobe ---------------" 
ddcprobe
echo "--------------- finished ddcprobe ---------------" 
sync
echo "--------------- start Xvesa -listmodes ---------------" 
Xvesa -listmodes 2>&1
echo "--------------- finished Xvesa -listmodes ---------------" 
sync
echo "--------------- start dmesg ---------------" 
/bin/dmesg
echo "--------------- finished dmesg ---------------" 
sync

cd /tmp
tar czf results$N.tar.gz hardware-test
rm -rf $TMPDIR
exit
